package com.polarsparc.android.droiddailytodo;

import java.util.Calendar;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TimePicker;

public class CreateTodoActivity extends Activity {
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_create_todo);
        
        // Due Time
        final TimePicker picker = (TimePicker) findViewById(R.id.time_due);
        picker.setIs24HourView(true);
		picker.setOnTimeChangedListener(new TimePicker.OnTimeChangedListener() {
			@Override
			public void onTimeChanged(TimePicker view, int hour, int minute) {
				Calendar cal = Calendar.getInstance();
				
				int curHour = cal.get(Calendar.HOUR_OF_DAY);
				int curMinute = cal.get(Calendar.MINUTE);
				
				if (hour >= curHour && minute > curMinute) {
					picker.setCurrentHour(hour);
					picker.setCurrentMinute(minute);
				}
			}
		});
		
		// Create button
		final Button create = (Button) findViewById(R.id.create_todo);
		create.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
		        // Title
				final EditText title = (EditText) findViewById(R.id.title_txt);
				
				// Due Time
				final TimePicker picker = (TimePicker) findViewById(R.id.time_due);
				
				if (title.getText().length() > 0) {
					Intent intent = getIntent();
					intent.putExtra("todoTitle", title.getText().toString());
					intent.putExtra("pickedHour", picker.getCurrentHour());
					intent.putExtra("pickedMinute", picker.getCurrentMinute());
					
					setResult(Activity.RESULT_OK, intent);
					
					// Close this activty
					finish();
				}
			}
		});
		
		// Cancel button
		final Button cancel = (Button) findViewById(R.id.cancel_todo);
		cancel.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				// Close this activty
				finish();
			}
		});
    }

}
