package com.polarsparc.android.droiddailytodo;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.ArrayList;

public class TodoTaskManager {
	private List<TodoTask> tasks = new ArrayList<TodoTask>();
	
	private TodoTaskComparator comparator = new TodoTaskComparator();
	
	public List<TodoTask> getTodoTaskList() {
		return tasks;
	}
	
	public void addAllTodoTasks(List<TodoTask> list) {
		tasks.addAll(list);
	}
	
	public TodoTask getTodoTask(int index) {
		return tasks.get(index);
	}
	
	public TodoTask addTodoTask(String title, int hour, int minute) {
		TodoTask entry = null;
		
		if (title != null && title.isEmpty() == false) {
			entry = new TodoTask();
			entry.setTitle(title);
			entry.setHour(hour);
			entry.setMinute(minute);
			
			tasks.add(entry);
			
			Collections.sort(tasks, comparator);
		}
		
		return entry;
	}
	
	public TodoTask removeTodoTask(int index) {
		return tasks.remove(index);
	}
	
	// ----- Inner Class(es) -----
	
	class TodoTaskComparator implements Comparator<TodoTask> {
	    public int compare(TodoTask one, TodoTask two) {
	    	if (one.getHour() < two.getHour()) {
	    		return -1;
	    	}
	    	if (one.getHour() > two.getHour()) {
	    		return 1;
	    	}
	    	if (one.getMinute() < two.getMinute()) {
	    		return -1;
	    	}
	    	if (one.getMinute() > two.getMinute()) {
	    		return 1;
	    	}
	    	return 0;
	    }
	}
}
